package com.css.simulation.oauth.client.mapper;


import api.common.pojo.po.UserPO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

@Mapper
public interface UserMapper {

    @Results(id = "user", value = {
            @Result(property = "id", column = "id", jdbcType = JdbcType.VARCHAR),
            @Result(property = "username", column = "username", jdbcType = JdbcType.VARCHAR),
            @Result(property = "password", column = "password", jdbcType = JdbcType.VARCHAR),
            @Result(property = "isDeleted", column = "is_deleted", jdbcType = JdbcType.VARCHAR)
    })
    @Select("select id,\n" +
            "       username,\n" +
            "       password,\n" +
            "       is_deleted\n" +
            "from system_user\n" +
            "where id = #{id}")
    UserPO selectByIdIgnoreDelete(@Param("id") String id);


    @ResultMap("user")
    @Select("select id,\n" +
            "       username,\n" +
            "       password\n" +
            "from system_user\n" +
            "where is_deleted = '0'\n" +
            "   and is_deactivate = '0'" +
            "   and username = #{username}")
    UserPO selectByUsername(@Param("username") String username);

    @Update("update system_user\n" +
            "set is_delete = #{isDeleted}\n" +
            "   where id = #{id}")
    void updateIsDeleted(@Param("id") String id,@Param("isDeleted") String isDeleted);




    //* -------------------------------- insert --------------------------------
    @Insert("insert into system_user(" +
            "   id, " +
            "   username," +
            "   nickname," +
            "   password, " +
            "   is_deleted" +
            ")values (" +
            "   #{id}," +
            "   #{username}," +
            "   #{nickname}," +
            "   #{password}," +
            "   #{isDeleted}" +
            ")")
    void insert(UserPO userPO);


}